Add an option for ignoring errors reading shadow information, because somebody
out there has a broken setup.
diff -uNr Linux-PAM-0.75/modules/pam_unix/README Linux-PAM-0.75/modules/pam_unix/README
--- Linux-PAM-0.75/modules/pam_unix/README	Tue Jun 20 18:12:02 2000
+++ Linux-PAM-0.75/modules/pam_unix/README	Tue Jul 10 00:14:23 2001
@@ -34,6 +34,8 @@
 	nis		-	use NIS RPC for setting new password
 	remember=X	-	remember X old passwords, they are kept in
 				/etc/security/opasswd in MD5 crypted form
+	broken_shadow	-	ignore errors reading shadow information for
+				users in the account management module
 
 	invalid arguments are logged to syslog.
 
diff -uNr Linux-PAM-0.75/modules/pam_unix/support.h Linux-PAM-0.75/modules/pam_unix/support.h
--- Linux-PAM-0.75/modules/pam_unix/support.h	Wed Dec 20 00:15:05 2000
+++ Linux-PAM-0.75/modules/pam_unix/support.h	Tue Jul 10 00:14:23 2001
@@ -80,8 +80,9 @@
 #define UNIX_BIGCRYPT            18	/* use DEC-C2 crypt()^x function */
 #define UNIX_LIKE_AUTH           19	/* need to auth for setcred to work */
 #define UNIX_REMEMBER_PASSWD     20	/* Remember N previous passwords */
+#define UNIX_BROKEN_SHADOW       21	/* Ignore errors reading shadow info */
 /* -------------- */
-#define UNIX_CTRLS_              21	/* number of ctrl arguments defined */
+#define UNIX_CTRLS_              22	/* number of ctrl arguments defined */
 
 
 static const UNIX_Ctrls unix_args[UNIX_CTRLS_] =
@@ -110,6 +111,7 @@
 /* UNIX_BIGCRYPT */        {"bigcrypt",        _ALL_ON_^(020000),    0400000},
 /* UNIX_LIKE_AUTH */       {"likeauth",        _ALL_ON_,            01000000},
 /* UNIX_REMEMBER_PASSWD */ {"remember=",       _ALL_ON_,            02000000},
+/* UNIX_BROKEN_SHADOW */   {"broken_shadow",   _ALL_ON_,            04000000},
 };
 
 #define UNIX_DEFAULTS  (unix_args[UNIX__NONULL].flag)
diff -uNr Linux-PAM-0.75/modules/pam_unix/pam_unix_acct.c Linux-PAM-0.75/modules/pam_unix/pam_unix_acct.c
--- Linux-PAM-0.75/modules/pam_unix/pam_unix_acct.c	Wed Dec 20 00:15:05 2000
+++ Linux-PAM-0.75/modules/pam_unix/pam_unix_acct.c	Tue Jul 10 00:14:23 2001
@@ -129,6 +129,10 @@
 	}
 
 	if (!spent)
+		if (ctrl & UNIX_BROKEN_SHADOW)
+			return PAM_SUCCESS;
+
+	if (!spent)
 		return PAM_AUTHINFO_UNAVAIL;	/* Couldn't get username from shadow */
 
 	curdays = time(NULL) / (60 * 60 * 24);
